// TeZ - SoS workshop  2018 - DS18S20 temperature sensor module + esp 32 //

#include <OneWire.h> 

// for WEMOS Connect VCC > 5v,  GND > G and SIG > D2

int DS18S20_Pin = 21; //DS18S20 Signal on pin D21 of ESP32

//Temperature chip i/o
OneWire ds(DS18S20_Pin); // on digital pin 2

void setup(void) {
Serial.begin(115200);
}

void loop(void) {
float temperature = getTemp(); //will take about 750ms to run
Serial.println(temperature);

}


float getTemp(){
    //returns the temperature from one DS18S20 in DEG Celsius
    
    byte data[12];
    byte addr[8];
    
    if ( !ds.search(addr)) {
    //no more sensors on chain, reset search
    ds.reset_search();
    return -1000;
    }
    
    if ( OneWire::crc8( addr, 7) != addr[7]) {
    Serial.println("CRC is not valid!");
    return -1000;
    }
    
    if ( addr[0] != 0x10 && addr[0] != 0x28) {
    Serial.print("Device is not recognized");
    return -1000;
    }
    
    ds.reset();
    ds.select(addr);
    ds.write(0x44,1); // start conversion, with parasite power on at the end
    
    // delay(750); // Wait for temperature conversion to complete
    delay(100); // Wait for temperature conversion to complete
    
    byte present = ds.reset();
    ds.select(addr); 
    ds.write(0xBE); // Read Scratchpad
    
    
    for (int i = 0; i < 9; i++) { // we need 9 bytes
    data[i] = ds.read();
    }
    
    ds.reset_search();
    
    byte MSB = data[1];
    byte LSB = data[0];
    
    float tempRead = ((MSB << 8) | LSB); //using two's compliment
    float TemperatureSum = tempRead / 16;
    
    return TemperatureSum;

}
